---
title: HTMLInputElement.stepDown()
slug: Web/API/HTMLInputElement/stepDown
tags:
  - API
  - HTML DOM
  - HTMLInputElement
  - Method
  - Reference
  - Text Field Selection API
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The <strong><code>HTMLInputElement.stepDown([n])</code></strong> method decrements the value of a numeric type of  {{HTMLElement("input")}} element by the value of the <code><a href="/en-US/docs/Web/HTML/Attributes/step">step</a></code> attribute or up to <code>n</code> multiples of the step attribute if a number is passed as the parameter. </span> The method, when invoked, decrements the {{htmlattrxref("value","input")}} by ({{htmlattrxref("step","input")}} * n), where n defaults to 1 if not specified, and <code><a href="/en-US/docs/Web/HTML/Attributes/step">step</a></code> defaults to the default value for <code>step</code> if not specified.</p>

<p>Valid on all numeric, date, and time input types that support the step attribute, including{{HTMLElement("input/date", "date")}}, {{HTMLElement("input/month", "month")}}, {{HTMLElement("input/week", "week")}}, {{HTMLElement("input/time", "time")}}, {{HTMLElement("input/datetime-local", "datetime-local")}}, {{HTMLElement("input/number", "number")}}, and {{HTMLElement("input/range", "range")}}.</p>

<p>Given <code class="brush: html">&lt;input id="myTime" type="time" max="17:00" step="900" value="17:00"&gt;</code>, invoking <code>myTime.step(3)</code> will change the value to 16:15, decrementing the time by <code>3 * 900</code>, or 45 minutes. <code>myTime.step()</code>, with no parameter, would have resulted in <code>16:45</code>, as <code>n</code> defaults to <code>1</code>.</p>

<pre class="brush: html">&lt;!--  decrements by intervals of 900 seconds (15 minute) --&gt;
<code class="brush: html">&lt;input type="time" max="17:00" step="900"&gt;</code>

&lt;!-- decrements by intervals of 7 days (one week) --&gt;
<code class="brush: html">&lt;input type="date" max="2019-12-25" step="7"&gt;</code>

&lt;!-- decrements by intervals of 12 months (one year) --&gt;
<code class="brush: html">&lt;input type="month" max="2019-12" step="12"&gt;</code></pre>

<p>The method, when invoked, changes the form control's value by the value given in the <code>step</code> attribute, multiplied by the parameter, within the constraints set within the form control. The default value for the parameter, if not is passed, is 1. The method will not cause the value to go below the <code><a href="/en-US/docs/Web/HTML/Attributes/min">min</a></code> value set or defy the constraints set by the <code><a href="/en-US/docs/Web/HTML/Attributes/step">step</a></code> attribute. A negative value for <code>n</code> will increment the value, but will not increment beyond the <code><a href="/en-US/docs/Web/HTML/Attributes/max">max</a></code> value.</p>

<p>If the value before invoking the <code>stepDown()</code> method is invalid, for example, if it doesn't match the constraints set by the <code>step</code> attribute, invoking the <code>stepDown()</code> method will return a value that does match the form controls constraints.</p>

<p>If the form control is non time, date, or numeric in nature, and therefore does not support the <code>step</code> attribute (see the list of supported input types in the table above), or if the <code>step</code> value is set to <code>any</code>, an <code>InvalidStateError</code> exception is thrown.</p>

<dl>
 <dt>{{domxref("HTMLInputElement.stepDown()")}}</dt>
 <dd>Decrements the {{htmlattrxref("value","input")}} by ({{htmlattrxref("step","input")}} * n), where n defaults to 1 if not specified. Throws an INVALID_STATE_ERR exception:
 <ul>
  <li>if the method is not applicable to for the current {{htmlattrxref("type","input")}} value,</li>
  <li>if the element has no {{htmlattrxref("step","input")}} value,</li>
  <li>if the {{htmlattrxref("value","input")}} cannot be converted to a number,</li>
  <li>if the resulting value is above the {{htmlattrxref("max","input")}} or below the {{htmlattrxref("min","input")}}.</li>
 </ul>
 </dd>
</dl>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>element</em>.stepDown(<em> [ stepDecrement ] </em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><em><code>stepDecrement</code></em></dt>
 <dd>The optional  <code><em>stepDecrement</em></code> paremeter is a numeric value.  If no parameter is passed, <em>stepDecrement</em> defaults to 1.</dd>
 <dd>If the value is a float, the value will increment as if <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Math/floor">Math.floor(stepDecrement)</a></code> was passed. If the value is negative, the value will be incremented instead of decremented.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>Click the button in this example to increment the {{HTMLElement("input/number", "number")}} input type:</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;p&gt;
  &lt;label&gt;Enter a number between 0 and 400 that is divisible by 5:
   &lt;input type="number" step="5" id="theNumber" min="0" max="400"&gt;
  &lt;/label&gt;
&lt;/p&gt;
&lt;p&gt;
  &lt;label&gt;Enter how many values of step you would like to increment by or leave it blank:
   &lt;input type="number" step="1" id="decrementer" min="-2" max="15"&gt;
  &lt;/label&gt;
&lt;/p&gt;
&lt;input type="button" value="Decrement" id="theButton"&gt;
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js">/* make the button call the function */
let button = document.getElementById('theButton');
button.addEventListener('click', function() {
  stepondown();}
);

function stepondown() {
  let input = document.getElementById('theNumber');
  let val = document.getElementById('decrementer').value;

  if (val) {  /* increment with a parameter */
    input.stepDown(val);
  } else {    /* or without a parameter. Try it with 0, 5, -2, etc. */
    input.stepDown();
  }
}</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css">input:invalid {
  border: red solid 3px;
}</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample("Example")}}</p>

<p>Note if you don't pass a parameter to the <code>stepDown()</code> method, it defaults to 1. Any other value is a multiplier of the <code>step</code> attribute value, which in this case is 5. If we pass 4 as the stepDecrement, the input will stepDown by <code>4 * 5</code>, or <code>20</code>. If the parameter is 0, the number will not be decremented. The stepDown() method will not allow the input to go out of range, in this case stopping when it reaches 0 and rounding down and floats that are passed as a parameter.</p>

<p>Try setting the step decrementer to <code>1.2</code>. What happens when you invoke the method?</p>

<p>Try setting the value to <code>44</code>, which is not valid. What happens when you invoke the method?</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("HTML WHATWG", "input.html#dom-input-stepdown", "stepDown()")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5.1", "sec-forms.html#dom-htmlinputelement-stepdown", "stepDown()")}}</td>
   <td>{{Spec2("HTML5.1")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5 W3C", "sec-forms.html#dom-htmlinputelement-stepdown", "stepDown()")}}</td>
   <td>{{Spec2("HTML5 W3C")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.HTMLInputElement.stepDown")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTMLElement("input")}}</li>
 <li>{{domxref("HTMLInputElement")}}</li>
 <li>{{domxref("HTMLInputElement.stepUp", "HTMLInputElement.stepUp()")}}</li>
 <li><code><a href="/en-US/docs/Web/HTML/Attributes/step">step</a></code>, <code><a href="/en-US/docs/Web/HTML/Attributes/min">min</a></code> and <code><a href="/en-US/docs/Web/HTML/Attributes/max">max</a></code> attributes</li>
</ul>
